#ifndef FEFE_RAW_H
#define FEFE_RAW_H

typedef struct raw_socket {
  struct libnet_link_int *l;
  char errbuf[256];
} rawsocket;

  /* 00:60:67:33:D1:5B -> char[6] */
int ethermac_scan(char *s,char *mac);
  /* char[6] -> 0:60:67:33:D1:5B */
unsigned int ethermac_fmt(char *s,char *mac);

  /* ourmac hismac arp 42: arp who-has hisip tell ourip (ourmac).
   * normally hismac == etherbroadcast */
int arp_sendwhois(rawsocket *,char *ourip,char *hisip,char *ourmac,char *hismac);
int arp_sendreply(rawsocket *,char *ourip,char *hisip,char *ourmac,char *hismac);

int socket_makearpwhois(char *s,char ourip[4],char hisip[4],char ourmac[6],char hismac[6]);
int socket_makearpreply(char *s,char ourip[4],char hisip[4],char ourmac[6],char hismac[6]);

int socket_mymac(rawsocket *,char *mac);

int socket_createraw(rawsocket *,char *device);
int socket_writeraw(rawsocket *,char *buf,int len);

int socket_defaultdevice(char **device);

static const unsigned char etherbroadcast[6] = {0xff,0xff,0xff,0xff,0xff,0xff};
static const unsigned char ethernull[6] = {0,0,0,0,0,0};

#endif
